libstdc++: std::ctype_byname< char > Class Reference

libstdc++

std::ctype_byname< char > Class Reference

`#include <locale_facets.h>`

Inheritance diagram for std::ctype_byname< char >:
[legend]

## Public Types
typedef const int * | __to_type
typedef char | char_type
typedef ctype< char >::mask | mask

## Public Member Functions
| ctype_byname (const char *__s, size_t __refs=0)
| ctype_byname (const string &__s, size_t __refs=0)
const char_type * | is (const char_type *__lo, const char_type *__hi, mask *__vec) const
bool | is (mask __m, char_type __c) const
const char_type * | is (const char_type *__lo, const char_type *__hi, mask *__vec) const
bool | is (mask __m, char_type __c) const
char | narrow (char_type __c, char __dfault) const
const char_type * | narrow (const char_type *__lo, const char_type *__hi, char __dfault, char *__to) const
char | narrow (char_type __c, char __dfault) const
const char_type * | narrow (const char_type *__lo, const char_type *__hi, char __dfault, char *__to) const
const char_type * | scan_is (mask __m, const char_type *__lo, const char_type *__hi) const
const char_type * | scan_is (mask __m, const char_type *__lo, const char_type *__hi) const
const char_type * | scan_not (mask __m, const char_type *__lo, const char_type *__hi) const
const char_type * | scan_not (mask __m, const char_type *__lo, const char_type *__hi) const
const mask * | table () const throw ()
const char_type * | tolower (char_type *__lo, const char_type *__hi) const
char_type | tolower (char_type __c) const
const char_type * | tolower (char_type *__lo, const char_type *__hi) const
char_type | tolower (char_type __c) const
const char_type * | toupper (char_type *__lo, const char_type *__hi) const
char_type | toupper (char_type __c) const
const char_type * | toupper (char_type *__lo, const char_type *__hi) const
char_type | toupper (char_type __c) const
const char * | widen (const char *__lo, const char *__hi, char_type *__to) const
char_type | widen (char __c) const
const char * | widen (const char *__lo, const char *__hi, char_type *__to) const

## Static Public Member Functions
static const mask * | classic_table () throw ()

## Static Public Attributes
static const mask | alnum
static const mask | alpha
static const mask | blank
static const mask | cntrl
static const mask | digit
static const mask | graph
static locale::id | id
static const mask | lower
static const mask | print
static const mask | punct
static const mask | space
static const size_t | table_size
static const mask | upper
static const mask | xdigit

## Protected Member Functions
virtual bool | do_is (mask __m, char_type __c) const
virtual const char_type * | do_is (const char_type *__lo, const char_type *__hi, mask *__vec) const
virtual bool | do_is (mask __m, char_type __c) const
virtual char | do_narrow (char_type __c, char __dfault) const
virtual const char_type * | do_narrow (const char_type *__lo, const char_type *__hi, char __dfault, char *__to) const
virtual char | do_narrow (char_type, char __dfault) const
virtual const char_type * | do_narrow (const char_type *__lo, const char_type *__hi, char __dfault, char *__to) const
virtual const char_type * | do_scan_is (mask __m, const char_type *__lo, const char_type *__hi) const
virtual const char_type * | do_scan_is (mask __m, const char_type *__lo, const char_type *__hi) const
virtual const char_type * | do_scan_not (mask __m, const char_type *__lo, const char_type *__hi) const
virtual const char_type * | do_scan_not (mask __m, const char_type *__lo, const char_type *__hi) const
virtual const char_type * | do_tolower (char_type *__lo, const char_type *__hi) const
virtual char_type | do_tolower (char_type __c) const
virtual const char_type * | do_tolower (char_type *__lo, const char_type *__hi) const
virtual char_type | do_tolower (char_type __c) const
virtual const char_type * | do_toupper (char_type *__lo, const char_type *__hi) const
virtual char_type | do_toupper (char_type __c) const
virtual const char_type * | do_toupper (char_type *__lo, const char_type *__hi) const
virtual char_type | do_toupper (char_type __c) const
virtual const char * | do_widen (const char *__lo, const char *__hi, char_type *__to) const
virtual char_type | do_widen (char __c) const
virtual const char * | do_widen (const char *__lo, const char *__hi, char_type *__dest) const

## Static Protected Member Functions
static __c_locale | _S_clone_c_locale (__c_locale &__cloc) throw ()
static void | _S_create_c_locale (__c_locale &__cloc, const char *__s, __c_locale __old=0)
static void | _S_destroy_c_locale (__c_locale &__cloc)
static __c_locale | _S_get_c_locale ()
static const char * | _S_get_c_name () throw ()
static __c_locale | _S_lc_ctype_c_locale (__c_locale __cloc, const char *__s)

## Protected Attributes
__c_locale | _M_c_locale_ctype
bool | _M_del
char | _M_narrow [1+static_cast< unsigned char >(-1)]
char | _M_narrow_ok
const mask * | _M_table
__to_type | _M_tolower
__to_type | _M_toupper
char | _M_widen [1+static_cast< unsigned char >(-1)]
char | _M_widen_ok

## Detailed Description

22.2.1.4 Class ctype_byname specializations.

Definition at line 1509 of file locale_facets.h.

## Member Typedef Documentation

## ◆ __to_type

typedef const int* std::ctype_base::__to_type

Definition at line 44 of file ctype_base.h.

## ◆ char_type

typedef char std::ctype< char >::char_type

Definition at line 621 of file locale_facets.h.

## ◆ mask

typedef ctype<char>::mask std::ctype_byname< char >::mask

Definition at line 1491 of file locale_facets.h.

## Member Function Documentation

## ◆ classic_table()

const mask * std::ctype< char >::classic_table | ( |  | ) |
throw | ( | ) |  |  |
| staticinherited

Returns a pointer to the C locale mask table.

## ◆ do_is() [1/3]

virtual bool std::ctype< char >::do_is | ( | mask | __m,
|  | char_type | __c ) const
| protectedvirtualinherited

Test char_type classification.

This function finds a mask M for c and compares it to mask m.

do_is() is a hook for a derived facet to change the behavior of classifying. do_is() must always return the same result for the same input.

Parameters

  __c | The char_type to find the mask of.
  __m | The mask to compare against.

Returns
  (M & __m) != 0.

## ◆ do_is() [2/3]

virtual const char_type * std::ctype< char >::do_is | ( | const char_type * | __lo,
|  | const char_type * | __hi,
|  | mask * | __vec ) const
| protectedvirtual

Return a mask array.

This function finds the mask for each char_type in the range [lo,hi) and successively writes it to vec. vec must have as many elements as the input.

do_is() is a hook for a derived facet to change the behavior of classifying. do_is() must always return the same result for the same input.

Parameters

  __lo | Pointer to start of range.
  __hi | Pointer to end of range.
  __vec | Pointer to an array of mask storage.

Returns
  __hi.

## ◆ do_is() [3/3]

virtual bool std::ctype< char >::do_is | ( | mask | __m,
|  | char_type | __c ) const
| protectedvirtual

Test char_type classification.

This function finds a mask M for c and compares it to mask m.

do_is() is a hook for a derived facet to change the behavior of classifying. do_is() must always return the same result for the same input.

Parameters

  __c | The char_type to find the mask of.
  __m | The mask to compare against.

Returns
  (M & __m) != 0.

## ◆ do_narrow() [1/4]

virtual char std::ctype< char >::do_narrow | ( | char_type | __c,
|  | char | __dfault ) const
| inlineprotectedvirtualinherited

Narrow char.

This virtual function converts the char to char using the simplest reasonable transformation. If the conversion fails, dfault is returned instead. For an underived ctype<char> facet, c will be returned unchanged.

do_narrow() is a hook for a derived facet to change the behavior of narrowing. do_narrow() must always return the same result for the same input.

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters

  __c | The char to convert.
  __dfault | Char to return if conversion fails.

Returns
  The converted char.

Definition at line 1144 of file locale_facets.h.

## ◆ do_narrow() [2/4]

virtual const char_type * std::ctype< char >::do_narrow | ( | const char_type * | __lo,
|  | const char_type * | __hi,
|  | char | __dfault,
|  | char * | __to ) const
| inlineprotectedvirtualinherited

Narrow char array to char array.

This virtual function converts each char in the range [lo,hi) to char using the simplest reasonable transformation and writes the results to the destination array. For any char in the input that cannot be converted, dfault is used instead. For an underived ctype<char> facet, the argument will be copied unchanged.

do_narrow() is a hook for a derived facet to change the behavior of narrowing. do_narrow() must always return the same result for the same input.

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters

  __lo | Pointer to start of range.
  __hi | Pointer to end of range.
  __dfault | Char to use if conversion fails.
  __to | Pointer to the destination array.

Returns
  __hi.

Definition at line 1170 of file locale_facets.h.

## ◆ do_narrow() [3/4]

virtual char std::ctype< char >::do_narrow | ( | char_type | ,
|  | char | __dfault ) const
| protectedvirtual

Narrow char_type to char.

This virtual function converts the argument to char using the simplest reasonable transformation. If the conversion fails, dfault is returned instead.

do_narrow() is a hook for a derived facet to change the behavior of narrowing. do_narrow() must always return the same result for the same input.

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters

  __c | The char_type to convert.
  __dfault | Char to return if conversion fails.

Returns
  The converted char.

## ◆ do_narrow() [4/4]

virtual const char_type * std::ctype< char >::do_narrow | ( | const char_type * | __lo,
|  | const char_type * | __hi,
|  | char | __dfault,
|  | char * | __to ) const
| protectedvirtual

Narrow char_type array to char.

This virtual function converts each char_type in the range [__lo,__hi) to char using the simplest reasonable transformation and writes the results to the destination array. For any element in the input that cannot be converted, __dfault is used instead.

do_narrow() is a hook for a derived facet to change the behavior of narrowing. do_narrow() must always return the same result for the same input.

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters

  __lo | Pointer to start of range.
  __hi | Pointer to end of range.
  __dfault | Char to use if conversion fails.
  __to | Pointer to the destination array.

Returns
  __hi.

## ◆ do_scan_is() [1/2]

virtual const char_type * std::ctype< char >::do_scan_is | ( | mask | __m,
|  | const char_type * | __lo,
|  | const char_type * | __hi ) const
| protectedvirtualinherited

Find char_type matching mask.

This function searches for and returns the first char_type c in [__lo,__hi) for which is(__m,c) is true.

do_scan_is() is a hook for a derived facet to change the behavior of match searching. do_is() must always return the same result for the same input.

Parameters

  __m | The mask to compare against.
  __lo | Pointer to start of range.
  __hi | Pointer to end of range.

Returns
  Pointer to a matching char_type if found, else __hi.

## ◆ do_scan_is() [2/2]

virtual const char_type * std::ctype< char >::do_scan_is | ( | mask | __m,
|  | const char_type * | __lo,
|  | const char_type * | __hi ) const
| protectedvirtual

Find char_type matching mask.

This function searches for and returns the first char_type c in [__lo,__hi) for which is(__m,c) is true.

do_scan_is() is a hook for a derived facet to change the behavior of match searching. do_is() must always return the same result for the same input.

Parameters

  __m | The mask to compare against.
  __lo | Pointer to start of range.
  __hi | Pointer to end of range.

Returns
  Pointer to a matching char_type if found, else __hi.

## ◆ do_scan_not() [1/2]

virtual const char_type * std::ctype< char >::do_scan_not | ( | mask | __m,
|  | const char_type * | __lo,
|  | const char_type * | __hi ) const
| protectedvirtualinherited

Find char_type not matching mask.

This function searches for and returns a pointer to the first char_type c of [lo,hi) for which is(m,c) is false.

do_scan_is() is a hook for a derived facet to change the behavior of match searching. do_is() must always return the same result for the same input.

Parameters

  __m | The mask to compare against.
  __lo | Pointer to start of range.
  __hi | Pointer to end of range.

Returns
  Pointer to a non-matching char_type if found, else __hi.

## ◆ do_scan_not() [2/2]

virtual const char_type * std::ctype< char >::do_scan_not | ( | mask | __m,
|  | const char_type * | __lo,
|  | const char_type * | __hi ) const
| protectedvirtual

Find char_type not matching mask.

This function searches for and returns a pointer to the first char_type c of [lo,hi) for which is(m,c) is false.

do_scan_is() is a hook for a derived facet to change the behavior of match searching. do_is() must always return the same result for the same input.

Parameters

  __m | The mask to compare against.
  __lo | Pointer to start of range.
  __hi | Pointer to end of range.

Returns
  Pointer to a non-matching char_type if found, else __hi.

## ◆ do_tolower() [1/4]

virtual const char_type * std::ctype< char >::do_tolower | ( | char_type * | __lo,
|  | const char_type * | __hi ) const
| protectedvirtualinherited

Convert array to lowercase.

This virtual function converts each char in the range [lo,hi) to lowercase if possible. Other chars remain untouched.

do_tolower() is a hook for a derived facet to change the behavior of lowercasing. do_tolower() must always return the same result for the same input.

Parameters

  __lo | Pointer to first char in range.
  __hi | Pointer to end of range.

Returns
  __hi.

References do_tolower().

## ◆ do_tolower() [2/4]

virtual char_type std::ctype< char >::do_tolower | ( | char_type | __c | ) | const
| protectedvirtualinherited

Convert to lowercase.

This virtual function converts the char argument to lowercase if possible. If not possible (for example, '2'), returns the argument.

do_tolower() is a hook for a derived facet to change the behavior of lowercasing. do_tolower() must always return the same result for the same input.

Parameters

  __c | The char to convert.

Returns
  The lowercase char if convertible, else __c.

References do_tolower().

Referenced by do_tolower(), and do_tolower().

## ◆ do_tolower() [3/4]

virtual const char_type * std::ctype< char >::do_tolower | ( | char_type * | __lo,
|  | const char_type * | __hi ) const
| protectedvirtual

Convert array to lowercase.

This virtual function converts each char_type in the range [__lo,__hi) to lowercase if possible. Other elements remain untouched.

do_tolower() is a hook for a derived facet to change the behavior of lowercasing. do_tolower() must always return the same result for the same input.

Parameters

  __lo | Pointer to start of range.
  __hi | Pointer to end of range.

Returns
  __hi.

## ◆ do_tolower() [4/4]

virtual char_type std::ctype< char >::do_tolower | ( | char_type | __c | ) | const
| protectedvirtual

Convert to lowercase.

This virtual function converts the argument to lowercase if possible. If not possible (for example, '2'), returns the argument.

do_tolower() is a hook for a derived facet to change the behavior of lowercasing. do_tolower() must always return the same result for the same input.

Parameters

  __c | The char_type to convert.

Returns
  The lowercase char_type if convertible, else __c.

## ◆ do_toupper() [1/4]

virtual const char_type * std::ctype< char >::do_toupper | ( | char_type * | __lo,
|  | const char_type * | __hi ) const
| protectedvirtualinherited

Convert array to uppercase.

This virtual function converts each char in the range [lo,hi) to uppercase if possible. Other chars remain untouched.

do_toupper() is a hook for a derived facet to change the behavior of uppercasing. do_toupper() must always return the same result for the same input.

Parameters

  __lo | Pointer to start of range.
  __hi | Pointer to end of range.

Returns
  __hi.

References do_toupper().

## ◆ do_toupper() [2/4]

virtual char_type std::ctype< char >::do_toupper | ( | char_type | __c | ) | const
| protectedvirtualinherited

Convert to uppercase.

This virtual function converts the char argument to uppercase if possible. If not possible (for example, '2'), returns the argument.

do_toupper() is a hook for a derived facet to change the behavior of uppercasing. do_toupper() must always return the same result for the same input.

Parameters

  __c | The char to convert.

Returns
  The uppercase char if convertible, else __c.

References do_toupper().

Referenced by do_toupper(), and do_toupper().

## ◆ do_toupper() [3/4]

virtual const char_type * std::ctype< char >::do_toupper | ( | char_type * | __lo,
|  | const char_type * | __hi ) const
| protectedvirtual

Convert array to uppercase.

This virtual function converts each char_type in the range [__lo,__hi) to uppercase if possible. Other elements remain untouched.

do_toupper() is a hook for a derived facet to change the behavior of uppercasing. do_toupper() must always return the same result for the same input.

Parameters

  __lo | Pointer to start of range.
  __hi | Pointer to end of range.

Returns
  __hi.

## ◆ do_toupper() [4/4]

virtual char_type std::ctype< char >::do_toupper | ( | char_type | __c | ) | const
| protectedvirtual

Convert to uppercase.

This virtual function converts the char_type argument to uppercase if possible. If not possible (for example, '2'), returns the argument.

do_toupper() is a hook for a derived facet to change the behavior of uppercasing. do_toupper() must always return the same result for the same input.

Parameters

  __c | The char_type to convert.

Returns
  The uppercase char_type if convertible, else __c.

## ◆ do_widen() [1/3]

virtual const char * std::ctype< char >::do_widen | ( | const char * | __lo,
|  | const char * | __hi,
|  | char_type * | __to ) const
| inlineprotectedvirtualinherited

Widen char array.

This function converts each char in the range [lo,hi) to char using the simplest reasonable transformation. For an underived ctype<char> facet, the argument will be copied unchanged.

do_widen() is a hook for a derived facet to change the behavior of widening. do_widen() must always return the same result for the same input.

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters

  __lo | Pointer to start of range.
  __hi | Pointer to end of range.
  __to | Pointer to the destination array.

Returns
  __hi.

Definition at line 1117 of file locale_facets.h.

## ◆ do_widen() [2/3]

virtual char_type std::ctype< char >::do_widen | ( | char | __c | ) | const
| protectedvirtual

Widen char.

This virtual function converts the char to char_type using the simplest reasonable transformation.

do_widen() is a hook for a derived facet to change the behavior of widening. do_widen() must always return the same result for the same input.

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters

  __c | The char to convert.

Returns
  The converted char_type

## ◆ do_widen() [3/3]

virtual const char * std::ctype< char >::do_widen | ( | const char * | __lo,
|  | const char * | __hi,
|  | char_type * | __dest ) const
| protectedvirtual

Widen char array.

This function converts each char in the input to char_type using the simplest reasonable transformation.

do_widen() is a hook for a derived facet to change the behavior of widening. do_widen() must always return the same result for the same input.

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters

  __lo | Pointer to start range.
  __hi | Pointer to end of range.
  __to | Pointer to the destination array.

Returns
  __hi.

## ◆ is() [1/4]

template<typename _CharT>

const char_type * std::__ctype_abstract_base< _CharT >::is | ( | const char_type * | __lo,
|  | const char_type * | __hi,
|  | mask * | __vec ) const
| inlineinherited

Return a mask array.

This function finds the mask for each char_type in the range [lo,hi) and successively writes it to vec. vec must have as many elements as the char array. It does so by returning the value of ctype<char_type>::do_is().

Parameters

  __lo | Pointer to start of range.
  __hi | Pointer to end of range.
  __vec | Pointer to an array of mask storage.

Returns
  __hi.

Definition at line 191 of file locale_facets.h.

## ◆ is() [2/4]

template<typename _CharT>

bool std::__ctype_abstract_base< _CharT >::is | ( | mask | __m,
|  | char_type | __c ) const
| inlineinherited

Test char_type classification.

This function finds a mask M for __c and compares it to mask __m. It does so by returning the value of ctype<char_type>::do_is().

Parameters

  __c | The char_type to compare the mask of.
  __m | The mask to compare against.

Returns
  (M & __m) != 0.

Definition at line 174 of file locale_facets.h.

Referenced by std::time_get< _CharT, _InIter >::get().

## ◆ is() [3/4]

const char_type * std::__ctype_abstract_base< char >::is | ( | const char_type * | __lo,
|  | const char_type * | __hi,
|  | mask * | __vec ) const
| inline

Return a mask array.

This function finds the mask for each char_type in the range [lo,hi) and successively writes it to vec. vec must have as many elements as the char array. It does so by returning the value of ctype<char_type>::do_is().

Parameters

  __lo | Pointer to start of range.
  __hi | Pointer to end of range.
  __vec | Pointer to an array of mask storage.

Returns
  __hi.

Definition at line 191 of file locale_facets.h.

## ◆ is() [4/4]

bool std::__ctype_abstract_base< char >::is | ( | mask | __m,
|  | char_type | __c ) const
| inline

Test char_type classification.

This function finds a mask M for __c and compares it to mask __m. It does so by returning the value of ctype<char_type>::do_is().

Parameters

  __c | The char_type to compare the mask of.
  __m | The mask to compare against.

Returns
  (M & __m) != 0.

Definition at line 174 of file locale_facets.h.

## ◆ narrow() [1/4]

template<typename _CharT>

char std::__ctype_abstract_base< _CharT >::narrow | ( | char_type | __c,
|  | char | __dfault ) const
| inlineinherited

Narrow char_type to char.

This function converts the char_type to char using the simplest reasonable transformation. If the conversion fails, dfault is returned instead. It does so by returning ctype<char_type>::do_narrow(__c).

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters

  __c | The char_type to convert.
  __dfault | Char to return if conversion fails.

Returns
  The converted char.

Definition at line 336 of file locale_facets.h.

Referenced by std::time_get< _CharT, _InIter >::do_get_year(), std::time_get< _CharT, _InIter >::get(), and std::time_put< _CharT, _OutIter >::put().

## ◆ narrow() [2/4]

template<typename _CharT>

const char_type * std::__ctype_abstract_base< _CharT >::narrow | ( | const char_type * | __lo,
|  | const char_type * | __hi,
|  | char | __dfault,
|  | char * | __to ) const
| inlineinherited

Narrow array to char array.

This function converts each char_type in the input to char using the simplest reasonable transformation and writes the results to the destination array. For any char_type in the input that cannot be converted, dfault is used instead. It does so by returning ctype<char_type>::do_narrow(__lo, __hi, __dfault, __to).

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters

  __lo | Pointer to start of range.
  __hi | Pointer to end of range.
  __dfault | Char to use if conversion fails.
  __to | Pointer to the destination array.

Returns
  __hi.

Definition at line 358 of file locale_facets.h.

## ◆ narrow() [3/4]

char std::__ctype_abstract_base< char >::narrow | ( | char_type | __c,
|  | char | __dfault ) const
| inline

Narrow char_type to char.

This function converts the char_type to char using the simplest reasonable transformation. If the conversion fails, dfault is returned instead. It does so by returning ctype<char_type>::do_narrow(__c).

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters

  __c | The char_type to convert.
  __dfault | Char to return if conversion fails.

Returns
  The converted char.

Definition at line 336 of file locale_facets.h.

## ◆ narrow() [4/4]

const char_type * std::__ctype_abstract_base< char >::narrow | ( | const char_type * | __lo,
|  | const char_type * | __hi,
|  | char | __dfault,
|  | char * | __to ) const
| inline

Narrow array to char array.

This function converts each char_type in the input to char using the simplest reasonable transformation and writes the results to the destination array. For any char_type in the input that cannot be converted, dfault is used instead. It does so by returning ctype<char_type>::do_narrow(__lo, __hi, __dfault, __to).

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters

  __lo | Pointer to start of range.
  __hi | Pointer to end of range.
  __dfault | Char to use if conversion fails.
  __to | Pointer to the destination array.

Returns
  __hi.

Definition at line 358 of file locale_facets.h.

## ◆ scan_is() [1/2]

template<typename _CharT>

const char_type * std::__ctype_abstract_base< _CharT >::scan_is | ( | mask | __m,
|  | const char_type * | __lo,
|  | const char_type * | __hi ) const
| inlineinherited

Find char_type matching a mask.

This function searches for and returns the first char_type c in [lo,hi) for which is(m,c) is true. It does so by returning ctype<char_type>::do_scan_is().

Parameters

  __m | The mask to compare against.
  __lo | Pointer to start of range.
  __hi | Pointer to end of range.

Returns
  Pointer to matching char_type if found, else __hi.

Definition at line 207 of file locale_facets.h.

## ◆ scan_is() [2/2]

const char_type * std::__ctype_abstract_base< char >::scan_is | ( | mask | __m,
|  | const char_type * | __lo,
|  | const char_type * | __hi ) const
| inline

Find char_type matching a mask.

This function searches for and returns the first char_type c in [lo,hi) for which is(m,c) is true. It does so by returning ctype<char_type>::do_scan_is().

Parameters

  __m | The mask to compare against.
  __lo | Pointer to start of range.
  __hi | Pointer to end of range.

Returns
  Pointer to matching char_type if found, else __hi.

Definition at line 207 of file locale_facets.h.

## ◆ scan_not() [1/2]

template<typename _CharT>

const char_type * std::__ctype_abstract_base< _CharT >::scan_not | ( | mask | __m,
|  | const char_type * | __lo,
|  | const char_type * | __hi ) const
| inlineinherited

Find char_type not matching a mask.

This function searches for and returns the first char_type c in [lo,hi) for which is(m,c) is false. It does so by returning ctype<char_type>::do_scan_not().

Parameters

  __m | The mask to compare against.
  __lo | Pointer to first char in range.
  __hi | Pointer to end of range.

Returns
  Pointer to non-matching char if found, else __hi.

Definition at line 223 of file locale_facets.h.

## ◆ scan_not() [2/2]

const char_type * std::__ctype_abstract_base< char >::scan_not | ( | mask | __m,
|  | const char_type * | __lo,
|  | const char_type * | __hi ) const
| inline

Find char_type not matching a mask.

This function searches for and returns the first char_type c in [lo,hi) for which is(m,c) is false. It does so by returning ctype<char_type>::do_scan_not().

Parameters

  __m | The mask to compare against.
  __lo | Pointer to first char in range.
  __hi | Pointer to end of range.

Returns
  Pointer to non-matching char if found, else __hi.

Definition at line 223 of file locale_facets.h.

## ◆ table()

const mask * std::ctype< char >::table | ( |  | ) | const
throw | ( | ) |  |  |
| inlineinherited

Returns a pointer to the mask table provided to the constructor, or the default from classic_table() if none was provided.

Definition at line 993 of file locale_facets.h.

## ◆ tolower() [1/4]

template<typename _CharT>

const char_type * std::__ctype_abstract_base< _CharT >::tolower | ( | char_type * | __lo,
|  | const char_type * | __hi ) const
| inlineinherited

Convert array to lowercase.

This function converts each char_type in the range [__lo,__hi) to lowercase if possible. Other elements remain untouched. It does so by returning ctype<char_type>:: do_tolower(__lo, __hi).

Parameters

  __lo | Pointer to start of range.
  __hi | Pointer to end of range.

Returns
  __hi.

Definition at line 281 of file locale_facets.h.

## ◆ tolower() [2/4]

template<typename _CharT>

char_type std::__ctype_abstract_base< _CharT >::tolower | ( | char_type | __c | ) | const
| inlineinherited

Convert to lowercase.

This function converts the argument to lowercase if possible. If not possible (for example, '2'), returns the argument. It does so by returning ctype<char_type>::do_tolower(c).

Parameters

  __c | The char_type to convert.

Returns
  The lowercase char_type if convertible, else __c.

Definition at line 266 of file locale_facets.h.

Referenced by std::time_get< _CharT, _InIter >::get().

## ◆ tolower() [3/4]

const char_type * std::__ctype_abstract_base< char >::tolower | ( | char_type * | __lo,
|  | const char_type * | __hi ) const
| inline

Convert array to lowercase.

This function converts each char_type in the range [__lo,__hi) to lowercase if possible. Other elements remain untouched. It does so by returning ctype<char_type>:: do_tolower(__lo, __hi).

Parameters

  __lo | Pointer to start of range.
  __hi | Pointer to end of range.

Returns
  __hi.

Definition at line 281 of file locale_facets.h.

## ◆ tolower() [4/4]

char_type std::__ctype_abstract_base< char >::tolower | ( | char_type | __c | ) | const
| inline

Convert to lowercase.

This function converts the argument to lowercase if possible. If not possible (for example, '2'), returns the argument. It does so by returning ctype<char_type>::do_tolower(c).

Parameters

  __c | The char_type to convert.

Returns
  The lowercase char_type if convertible, else __c.

Definition at line 266 of file locale_facets.h.

## ◆ toupper() [1/4]

template<typename _CharT>

const char_type * std::__ctype_abstract_base< _CharT >::toupper | ( | char_type * | __lo,
|  | const char_type * | __hi ) const
| inlineinherited

Convert array to uppercase.

This function converts each char_type in the range [lo,hi) to uppercase if possible. Other elements remain untouched. It does so by returning ctype<char_type>:: do_toupper(lo, hi).

Parameters

  __lo | Pointer to start of range.
  __hi | Pointer to end of range.

Returns
  __hi.

Definition at line 252 of file locale_facets.h.

## ◆ toupper() [2/4]

template<typename _CharT>

char_type std::__ctype_abstract_base< _CharT >::toupper | ( | char_type | __c | ) | const
| inlineinherited

Convert to uppercase.

This function converts the argument to uppercase if possible. If not possible (for example, '2'), returns the argument. It does so by returning ctype<char_type>::do_toupper().

Parameters

  __c | The char_type to convert.

Returns
  The uppercase char_type if convertible, else __c.

Definition at line 237 of file locale_facets.h.

Referenced by std::time_get< _CharT, _InIter >::get().

## ◆ toupper() [3/4]

const char_type * std::__ctype_abstract_base< char >::toupper | ( | char_type * | __lo,
|  | const char_type * | __hi ) const
| inline

Convert array to uppercase.

This function converts each char_type in the range [lo,hi) to uppercase if possible. Other elements remain untouched. It does so by returning ctype<char_type>:: do_toupper(lo, hi).

Parameters

  __lo | Pointer to start of range.
  __hi | Pointer to end of range.

Returns
  __hi.

Definition at line 252 of file locale_facets.h.

## ◆ toupper() [4/4]

char_type std::__ctype_abstract_base< char >::toupper | ( | char_type | __c | ) | const
| inline

Convert to uppercase.

This function converts the argument to uppercase if possible. If not possible (for example, '2'), returns the argument. It does so by returning ctype<char_type>::do_toupper().

Parameters

  __c | The char_type to convert.

Returns
  The uppercase char_type if convertible, else __c.

Definition at line 237 of file locale_facets.h.

## ◆ widen() [1/3]

template<typename _CharT>

const char * std::__ctype_abstract_base< _CharT >::widen | ( | const char * | __lo,
|  | const char * | __hi,
|  | char_type * | __to ) const
| inlineinherited

Widen array to char_type.

This function converts each char in the input to char_type using the simplest reasonable transformation. It does so by returning ctype<char_type>::do_widen(c).

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters

  __lo | Pointer to start of range.
  __hi | Pointer to end of range.
  __to | Pointer to the destination array.

Returns
  __hi.

Definition at line 317 of file locale_facets.h.

## ◆ widen() [2/3]

char_type std::__ctype_abstract_base< char >::widen | ( | char | __c | ) | const
| inline

Widen char to char_type.

This function converts the char argument to char_type using the simplest reasonable transformation. It does so by returning ctype<char_type>::do_widen(c).

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters

  __c | The char to convert.

Returns
  The converted char_type.

Definition at line 298 of file locale_facets.h.

## ◆ widen() [3/3]

const char * std::__ctype_abstract_base< char >::widen | ( | const char * | __lo,
|  | const char * | __hi,
|  | char_type * | __to ) const
| inline

Widen array to char_type.

This function converts each char in the input to char_type using the simplest reasonable transformation. It does so by returning ctype<char_type>::do_widen(c).

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters

  __lo | Pointer to start of range.
  __hi | Pointer to end of range.
  __to | Pointer to the destination array.

Returns
  __hi.

Definition at line 317 of file locale_facets.h.

## Member Data Documentation

## ◆ _M_c_locale_ctype

__c_locale std::ctype< char >::_M_c_locale_ctype
| protectedinherited

Definition at line 700 of file locale_facets.h.

## ◆ _M_del

bool std::ctype< char >::_M_del
| protectedinherited

Definition at line 701 of file locale_facets.h.

## ◆ _M_narrow

char std::ctype< char >::_M_narrow[1+static_cast< unsigned char >(-1)]
| mutableprotectedinherited

Definition at line 707 of file locale_facets.h.

## ◆ _M_narrow_ok

char std::ctype< char >::_M_narrow_ok
| mutableprotectedinherited

Definition at line 708 of file locale_facets.h.

## ◆ _M_table

const mask* std::ctype< char >::_M_table
| protectedinherited

Definition at line 704 of file locale_facets.h.

## ◆ _M_tolower

__to_type std::ctype< char >::_M_tolower
| protectedinherited

Definition at line 703 of file locale_facets.h.

## ◆ _M_toupper

__to_type std::ctype< char >::_M_toupper
| protectedinherited

Definition at line 702 of file locale_facets.h.

## ◆ _M_widen

char std::ctype< char >::_M_widen[1+static_cast< unsigned char >(-1)]
| mutableprotectedinherited

Definition at line 706 of file locale_facets.h.

## ◆ _M_widen_ok

char std::ctype< char >::_M_widen_ok
| mutableprotectedinherited

Definition at line 705 of file locale_facets.h.

## ◆ alnum

const mask std::ctype_base::alnum
| static

Definition at line 59 of file ctype_base.h.

## ◆ alpha

const mask std::ctype_base::alpha
| static

Definition at line 51 of file ctype_base.h.

## ◆ blank

const mask std::ctype_base::blank
| static

Definition at line 61 of file ctype_base.h.

## ◆ cntrl

const mask std::ctype_base::cntrl
| static

Definition at line 57 of file ctype_base.h.

## ◆ digit

const mask std::ctype_base::digit
| static

Definition at line 52 of file ctype_base.h.

## ◆ graph

const mask std::ctype_base::graph
| static

Definition at line 56 of file ctype_base.h.

## ◆ id

locale::id std::ctype< char >::id
| static

The facet id for ctype<char_type>.

Definition at line 625 of file locale_facets.h.

## ◆ lower

const mask std::ctype_base::lower
| static

Definition at line 50 of file ctype_base.h.

## ◆ print

const mask std::ctype_base::print
| static

Definition at line 55 of file ctype_base.h.

## ◆ punct

const mask std::ctype_base::punct
| static

Definition at line 58 of file ctype_base.h.

## ◆ space

const mask std::ctype_base::space
| static

Definition at line 54 of file ctype_base.h.

## ◆ table_size

const size_t std::ctype< char >::table_size
| staticinherited

The size of the mask table. It is SCHAR_MAX + 1.

Definition at line 715 of file locale_facets.h.

## ◆ upper

const mask std::ctype_base::upper
| static

Definition at line 49 of file ctype_base.h.

## ◆ xdigit

const mask std::ctype_base::xdigit
| static

Definition at line 53 of file ctype_base.h.

The documentation for this class was generated from the following file:

- locale_facets.h